/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 21 "../../../phaver/src/parser.yy" /* yacc.c:339  */

#include "parameters.hh"
#include "convex_clock_val_set.hh"
#include "clock_val_set.hh"
#include "stopwatch.hh"
#include "symb_states_type.hh"
#include "automaton.hh"

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <memory>
#include <string>

#ifndef NDEBUG
#define YYDEBUG 1
#endif

#include "parser.hh"

extern FILE* yyin;
int yylex();

void
yyerror(const std::string& str) {
  std::cout << "Parse error in line " << line_number << ": ";
  std::cout << str << "\n";
  exit(1);
}

inline int
atoi_consume(const std::string* ptr) {
  int res = atoi(ptr->c_str());
  delete ptr;
  return res;
}

inline void
check_ident_consume(const std::string* ptr,
                    const std::string& expected) {
  const auto& parsed = *ptr;
  if (parsed != expected)
    yyerror("Expecting `" + expected + "', found `" + parsed + "'.");
  delete ptr;
}

void
parse_file(const std::string& filename) {
  /* doesn't deal with recursive loads */
  yyin = fopen(filename.c_str(), "r");
  if (yyin == nullptr) {
    std::cout << "*** Error opening `" << filename << "' ***\n";
    exit(1);
  }
  stopwatch sw(2001, "file " + filename);
  line_number = 1;
  yyparse();
  fclose(yyin);
}

Cons
identity_dpost(dim_type dim, const var_ref_set& contr_vars) {
  Cons dpost;
  for (auto vid : contr_vars)
    dpost.push_back(Var(vid) == Var(vid + dim));
  return dpost;
}

var_ref_set
get_dpost_unconstrained(dim_type dim, const Cons& dpost,
                        const var_ref_set& contr_vars) {
  var_ref_set res = contr_vars;
  for (const auto& c : dpost) {
    for (auto j = c.space_dim(); j-- > dim; ) {
      if (c.coeff(Var(j)) != 0)
        res.erase(j - dim);
    }
  }
  return res;
}

void
check_dpost(dim_type dim, const Cons& dpost,
            const var_ref_set& contr_vars) {
  auto not_seen = get_dpost_unconstrained(dim, dpost, contr_vars);
  if (!not_seen.empty())
    yyerror("Discrete post does not mention a controlled variable.");
}

void
maybe_fix_dpost(dim_type dim, Cons& dpost, const var_ref_set& contr_vars) {
  if (!PARSER_FIX_DPOST)
    return;
  auto not_seen = get_dpost_unconstrained(dim, dpost, contr_vars);
  if (not_seen.empty())
    return;
  auto fix = identity_dpost(dim, not_seen);
  dpost.insert(dpost.end(), fix.begin(), fix.end());
}

automaton* paut;
symb_states_type* psymb_state;
dim_type val_set_dim;

using RAE_Map = std::map<std::string, Rat_Affine_Expr>;
RAE_Map rae_map;

// Note: these are NON-owning (automaton) pointers.
using SS_Map = std::map<std::string, std::pair<symb_states_type, automaton*>>;
SS_Map ss_map;

// Note: these are owning (automaton) pointers.
using PAUT_Map = std::map<std::string, std::unique_ptr<automaton>>;
PAUT_Map paut_map;

std::string outfilename = "out";
std::ofstream file_out;
std::string current_loc_name;

using std::string;
using std::make_pair;
using std::cout;
using std::endl;

using pplite::Con;
using pplite::Cons;


#line 196 "parser.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_PARSER_HH_INCLUDED
# define YY_YY_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    par_POLY_KIND = 258,
    MERGE_SPLITTED = 259,
    ASAP = 260,
    par_TIME_POST_ITER = 261,
    par_TIME_POST_CONE_LAMBDA = 262,
    par_TIME_POST_CONE_WIDEN_DELAY = 263,
    par_TIME_POST_CONE_WIDEN_PRECISION = 264,
    par_MEMORY_MODE = 265,
    par_MAINTAIN_BOXED_CCVS = 266,
    par_PARSER_FIX_DPOST = 267,
    par_REACH_CHEAP_CONTAINS = 268,
    par_REACH_CHEAP_CONTAINS_USE_BBOX = 269,
    par_REACH_USE_BBOX = 270,
    par_REACH_USE_CONSTRAINT_HULL = 271,
    par_REACH_USE_CONVEX_HULL = 272,
    par_REACH_USE_TIME_ELAPSE = 273,
    par_REACH_STOP_AT_FORB = 274,
    par_REACH_MAX_ITER = 275,
    par_REACH_REPORT_INTERVAL = 276,
    par_REACH_USE_BBOX_ITER = 277,
    par_REACH_STOP_USE_CONVEX_HULL_ITER = 278,
    par_REACH_STOP_USE_CONVEX_HULL_SETTLE = 279,
    par_REACH_CONSTRAINT_LIMIT = 280,
    par_LIMIT_CONSTRAINTS_METHOD = 281,
    par_TP_CONSTRAINT_LIMIT = 282,
    par_REACH_CONSTRAINT_TRIGGER = 283,
    par_REACH_BITSIZE_TRIGGER = 284,
    par_CONSTRAINT_BITSIZE = 285,
    par_SEARCH_METHOD = 286,
    par_SEARCH_METHOD_TOPSORT_TOKENS = 287,
    par_SNAPSHOT_INTERVAL = 288,
    par_REFINE_DERIVATIVE_METHOD = 289,
    par_REFINE_PRIORITIZE_REACH_SPLIT = 290,
    par_REFINE_SMALLEST_FIRST = 291,
    par_REFINE_USE_FP = 292,
    par_REFINE_DERIV_MINANGLE = 293,
    par_REFINE_PRIORITIZE_ANGLE = 294,
    par_REFINE_CHECK_TIME_RELEVANCE = 295,
    par_REFINE_CHECK_TIME_RELEVANCE_DURING = 296,
    par_REFINE_CHECK_TIME_RELEVANCE_FINAL = 297,
    par_REFINE_CHECK_TRANS_DIMS = 298,
    par_REFINE_PARTITION_INSIDE = 299,
    par_REACH_FB_REFINE_METHOD = 300,
    par_REFINE_MAX_CHECKS = 301,
    par_REFINE_USE_NEW_SPLIT = 302,
    par_MINIMIZE_FILTER_THRESHOLD = 303,
    PROJECT_TO = 304,
    DIFFERENCE_ASSIGN = 305,
    RENAME = 306,
    IS_REACHABLE = 307,
    IS_REACHABLE_FB = 308,
    INVARIANT_ASSIGN = 309,
    REVERSE = 310,
    SAVE_FP_SURFACE = 311,
    REACH_FORWARD_ITER = 312,
    UNLOCK_SURFACE_LOCS = 313,
    UNLOCK_LOCS = 314,
    GET_INVARIANTS = 315,
    PRINT_GRAPH = 316,
    INVERSE = 317,
    CONTAINS = 318,
    REFINE_CONSTRAINTS = 319,
    ADD_LABEL = 320,
    WHO = 321,
    SAVE_FP_INVARS = 322,
    INITIAL_STATES = 323,
    REFINE_LOCS = 324,
    REFINE_LOC_DERIV = 325,
    IS_EMPTY = 326,
    INTERSECTION_ASSIGN = 327,
    LOC_INTERSECTION = 328,
    LOC_UNION = 329,
    REMOVE = 330,
    MY_ECHO = 331,
    GET_PARAMETERS = 332,
    PRINT = 333,
    SAVE_CON_FP = 334,
    SAVE_GEN_FP = 335,
    REACH = 336,
    REACH_STOP = 337,
    DEFNE = 338,
    AUTOMATON = 339,
    INTERNAL_VAR = 340,
    EXTERNAL_VAR = 341,
    PARAMETER = 342,
    SYNCLABS = 343,
    INITIALLY = 344,
    LOC = 345,
    WHILE = 346,
    WHEN = 347,
    TRUE = 348,
    FALSE = 349,
    ASSIGN = 350,
    INT = 351,
    IDENT = 352,
    STARIDENT = 353,
    STRING_TEXT = 354,
    GE = 355,
    LE = 356,
    EQ = 357,
    PRIM = 358
  };
#endif
/* Tokens.  */
#define par_POLY_KIND 258
#define MERGE_SPLITTED 259
#define ASAP 260
#define par_TIME_POST_ITER 261
#define par_TIME_POST_CONE_LAMBDA 262
#define par_TIME_POST_CONE_WIDEN_DELAY 263
#define par_TIME_POST_CONE_WIDEN_PRECISION 264
#define par_MEMORY_MODE 265
#define par_MAINTAIN_BOXED_CCVS 266
#define par_PARSER_FIX_DPOST 267
#define par_REACH_CHEAP_CONTAINS 268
#define par_REACH_CHEAP_CONTAINS_USE_BBOX 269
#define par_REACH_USE_BBOX 270
#define par_REACH_USE_CONSTRAINT_HULL 271
#define par_REACH_USE_CONVEX_HULL 272
#define par_REACH_USE_TIME_ELAPSE 273
#define par_REACH_STOP_AT_FORB 274
#define par_REACH_MAX_ITER 275
#define par_REACH_REPORT_INTERVAL 276
#define par_REACH_USE_BBOX_ITER 277
#define par_REACH_STOP_USE_CONVEX_HULL_ITER 278
#define par_REACH_STOP_USE_CONVEX_HULL_SETTLE 279
#define par_REACH_CONSTRAINT_LIMIT 280
#define par_LIMIT_CONSTRAINTS_METHOD 281
#define par_TP_CONSTRAINT_LIMIT 282
#define par_REACH_CONSTRAINT_TRIGGER 283
#define par_REACH_BITSIZE_TRIGGER 284
#define par_CONSTRAINT_BITSIZE 285
#define par_SEARCH_METHOD 286
#define par_SEARCH_METHOD_TOPSORT_TOKENS 287
#define par_SNAPSHOT_INTERVAL 288
#define par_REFINE_DERIVATIVE_METHOD 289
#define par_REFINE_PRIORITIZE_REACH_SPLIT 290
#define par_REFINE_SMALLEST_FIRST 291
#define par_REFINE_USE_FP 292
#define par_REFINE_DERIV_MINANGLE 293
#define par_REFINE_PRIORITIZE_ANGLE 294
#define par_REFINE_CHECK_TIME_RELEVANCE 295
#define par_REFINE_CHECK_TIME_RELEVANCE_DURING 296
#define par_REFINE_CHECK_TIME_RELEVANCE_FINAL 297
#define par_REFINE_CHECK_TRANS_DIMS 298
#define par_REFINE_PARTITION_INSIDE 299
#define par_REACH_FB_REFINE_METHOD 300
#define par_REFINE_MAX_CHECKS 301
#define par_REFINE_USE_NEW_SPLIT 302
#define par_MINIMIZE_FILTER_THRESHOLD 303
#define PROJECT_TO 304
#define DIFFERENCE_ASSIGN 305
#define RENAME 306
#define IS_REACHABLE 307
#define IS_REACHABLE_FB 308
#define INVARIANT_ASSIGN 309
#define REVERSE 310
#define SAVE_FP_SURFACE 311
#define REACH_FORWARD_ITER 312
#define UNLOCK_SURFACE_LOCS 313
#define UNLOCK_LOCS 314
#define GET_INVARIANTS 315
#define PRINT_GRAPH 316
#define INVERSE 317
#define CONTAINS 318
#define REFINE_CONSTRAINTS 319
#define ADD_LABEL 320
#define WHO 321
#define SAVE_FP_INVARS 322
#define INITIAL_STATES 323
#define REFINE_LOCS 324
#define REFINE_LOC_DERIV 325
#define IS_EMPTY 326
#define INTERSECTION_ASSIGN 327
#define LOC_INTERSECTION 328
#define LOC_UNION 329
#define REMOVE 330
#define MY_ECHO 331
#define GET_PARAMETERS 332
#define PRINT 333
#define SAVE_CON_FP 334
#define SAVE_GEN_FP 335
#define REACH 336
#define REACH_STOP 337
#define DEFNE 338
#define AUTOMATON 339
#define INTERNAL_VAR 340
#define EXTERNAL_VAR 341
#define PARAMETER 342
#define SYNCLABS 343
#define INITIALLY 344
#define LOC 345
#define WHILE 346
#define WHEN 347
#define TRUE 348
#define FALSE 349
#define ASSIGN 350
#define INT 351
#define IDENT 352
#define STARIDENT 353
#define STRING_TEXT 354
#define GE 355
#define LE 356
#define EQ 357
#define PRIM 358

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 151 "../../../phaver/src/parser.yy" /* yacc.c:355  */

 std::string* mystring;
 pplite::Con* con;
 pplite::Cons* con_list;
 RefinementCon* refinement_con;
 RefinementCons* refinement_cons;
 var_ref_set* vrs;
 clock_val_set* cvs;
 std::list<std::string>* ident_list;
 bool mybool;
 Rat_Affine_Expr* rae;
 symb_states_type* symb_state;

#line 456 "parser.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 473 "parser.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  106
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   626

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  124
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  46
/* YYNRULES -- Number of rules.  */
#define YYNRULES  183
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  568

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   358

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   111,     2,     2,     2,     2,   101,     2,
     112,   113,   109,   107,   118,   108,   117,   110,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   123,   115,
     105,   116,   106,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   119,     2,   120,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,   100,   122,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   102,   103,   104,   114
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   301,   301,   304,   305,   311,   312,   316,   318,   340,
     355,   378,   418,   437,   436,   454,   453,   478,   477,   497,
     519,   530,   541,   555,   569,   581,   595,   609,   626,   638,
     656,   683,   697,   712,   711,   743,   752,   763,   776,   788,
     807,   826,   852,   879,   906,   912,   943,   953,   952,   966,
     978,   990,  1005,  1022,  1024,  1026,  1028,  1030,  1033,  1061,
    1084,  1091,  1100,  1102,  1107,  1109,  1111,  1114,  1117,  1119,
    1121,  1123,  1125,  1127,  1129,  1131,  1133,  1135,  1137,  1139,
    1141,  1143,  1145,  1147,  1149,  1151,  1153,  1155,  1161,  1163,
    1165,  1167,  1169,  1171,  1173,  1191,  1193,  1196,  1198,  1200,
    1202,  1204,  1206,  1208,  1210,  1212,  1217,  1218,  1223,  1222,
    1241,  1244,  1246,  1247,  1248,  1249,  1253,  1267,  1271,  1275,
    1279,  1285,  1294,  1300,  1309,  1315,  1324,  1330,  1337,  1347,
    1359,  1365,  1378,  1383,  1391,  1404,  1420,  1421,  1422,  1423,
    1427,  1443,  1444,  1451,  1467,  1483,  1497,  1514,  1531,  1548,
    1554,  1563,  1573,  1587,  1587,  1597,  1600,  1606,  1612,  1617,
    1621,  1632,  1640,  1643,  1649,  1660,  1671,  1682,  1697,  1706,
    1715,  1724,  1733,  1742,  1747,  1755,  1762,  1776,  1798,  1808,
    1816,  1822,  1828,  1833
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "par_POLY_KIND", "MERGE_SPLITTED",
  "ASAP", "par_TIME_POST_ITER", "par_TIME_POST_CONE_LAMBDA",
  "par_TIME_POST_CONE_WIDEN_DELAY", "par_TIME_POST_CONE_WIDEN_PRECISION",
  "par_MEMORY_MODE", "par_MAINTAIN_BOXED_CCVS", "par_PARSER_FIX_DPOST",
  "par_REACH_CHEAP_CONTAINS", "par_REACH_CHEAP_CONTAINS_USE_BBOX",
  "par_REACH_USE_BBOX", "par_REACH_USE_CONSTRAINT_HULL",
  "par_REACH_USE_CONVEX_HULL", "par_REACH_USE_TIME_ELAPSE",
  "par_REACH_STOP_AT_FORB", "par_REACH_MAX_ITER",
  "par_REACH_REPORT_INTERVAL", "par_REACH_USE_BBOX_ITER",
  "par_REACH_STOP_USE_CONVEX_HULL_ITER",
  "par_REACH_STOP_USE_CONVEX_HULL_SETTLE", "par_REACH_CONSTRAINT_LIMIT",
  "par_LIMIT_CONSTRAINTS_METHOD", "par_TP_CONSTRAINT_LIMIT",
  "par_REACH_CONSTRAINT_TRIGGER", "par_REACH_BITSIZE_TRIGGER",
  "par_CONSTRAINT_BITSIZE", "par_SEARCH_METHOD",
  "par_SEARCH_METHOD_TOPSORT_TOKENS", "par_SNAPSHOT_INTERVAL",
  "par_REFINE_DERIVATIVE_METHOD", "par_REFINE_PRIORITIZE_REACH_SPLIT",
  "par_REFINE_SMALLEST_FIRST", "par_REFINE_USE_FP",
  "par_REFINE_DERIV_MINANGLE", "par_REFINE_PRIORITIZE_ANGLE",
  "par_REFINE_CHECK_TIME_RELEVANCE",
  "par_REFINE_CHECK_TIME_RELEVANCE_DURING",
  "par_REFINE_CHECK_TIME_RELEVANCE_FINAL", "par_REFINE_CHECK_TRANS_DIMS",
  "par_REFINE_PARTITION_INSIDE", "par_REACH_FB_REFINE_METHOD",
  "par_REFINE_MAX_CHECKS", "par_REFINE_USE_NEW_SPLIT",
  "par_MINIMIZE_FILTER_THRESHOLD", "PROJECT_TO", "DIFFERENCE_ASSIGN",
  "RENAME", "IS_REACHABLE", "IS_REACHABLE_FB", "INVARIANT_ASSIGN",
  "REVERSE", "SAVE_FP_SURFACE", "REACH_FORWARD_ITER",
  "UNLOCK_SURFACE_LOCS", "UNLOCK_LOCS", "GET_INVARIANTS", "PRINT_GRAPH",
  "INVERSE", "CONTAINS", "REFINE_CONSTRAINTS", "ADD_LABEL", "WHO",
  "SAVE_FP_INVARS", "INITIAL_STATES", "REFINE_LOCS", "REFINE_LOC_DERIV",
  "IS_EMPTY", "INTERSECTION_ASSIGN", "LOC_INTERSECTION", "LOC_UNION",
  "REMOVE", "MY_ECHO", "GET_PARAMETERS", "PRINT", "SAVE_CON_FP",
  "SAVE_GEN_FP", "REACH", "REACH_STOP", "DEFNE", "AUTOMATON",
  "INTERNAL_VAR", "EXTERNAL_VAR", "PARAMETER", "SYNCLABS", "INITIALLY",
  "LOC", "WHILE", "WHEN", "TRUE", "FALSE", "ASSIGN", "INT", "IDENT",
  "STARIDENT", "STRING_TEXT", "'|'", "'&'", "GE", "LE", "EQ", "'<'", "'>'",
  "'+'", "'-'", "'*'", "'/'", "'!'", "'('", "')'", "PRIM", "';'", "'='",
  "'.'", "','", "'['", "']'", "'{'", "'}'", "':'", "$accept", "program",
  "commands", "command", "$@1", "$@2", "$@3", "$@4", "$@5", "DO", "END",
  "GOTO", "SYNC", "WAIT", "var_ref_list", "prelim", "bool_type",
  "automaton", "$@6", "automaton_body", "declaration", "synclab",
  "internal_vars", "external_vars", "parameters", "ivar_list", "evar_list",
  "param_list", "ident_list", "compose_list", "initial", "state_list",
  "location_list", "location", "transition_list", "transition",
  "refinement_cons", "refinement_con", "state_val_set", "$@7",
  "dpost_cons", "val_set", "constr_list", "constr_list_no_and", "constr",
  "rat_aff_expr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     124,    38,   355,   356,   357,    60,    62,    43,    45,    42,
      47,    33,    40,    41,   358,    59,    61,    46,    44,    91,
      93,   123,   125,    58
};
# endif

#define YYPACT_NINF -493

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-493)))

#define YYTABLE_NINF -57

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     138,   -81,   -40,   -24,    -7,    26,    74,    89,   152,   158,
     160,   168,   170,   177,   183,   184,   190,   197,   211,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   104,   241,   244,   260,   -69,
     307,   138,  -493,  -493,  -493,   261,   263,   105,   264,   265,
     266,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     102,   267,   268,   269,   106,   270,   106,   271,   272,   273,
     274,   275,   276,   277,   278,   106,   106,   106,   105,   106,
     106,   106,   106,   106,   106,   280,   281,   106,   282,  -493,
     279,   283,  -493,   105,   284,    49,  -493,  -493,   285,   286,
    -493,   212,   105,   105,   150,   287,   288,   289,  -493,  -493,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   308,   309,   310,
     311,   312,   313,   319,   320,   322,   323,   324,   154,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,  -493,
     335,  -493,   163,    94,   -26,   338,   339,   340,   341,   342,
     343,   344,   345,   346,  -493,   348,   349,   350,   351,   352,
     353,   354,   359,   360,   -87,   357,   314,   336,  -493,  -493,
    -493,  -493,   188,   105,   105,   105,   105,  -493,  -493,  -493,
    -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,
    -493,   362,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,
    -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,
    -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,
     106,   318,   224,  -493,   367,  -493,     0,   368,  -493,   372,
     381,   382,  -493,   383,   384,  -493,   385,   386,   373,   389,
     388,   391,   392,  -493,  -493,   393,  -493,  -493,   394,  -493,
     395,   379,   380,  -493,   157,   157,  -493,  -493,  -493,   387,
    -493,  -493,   256,   259,   374,   375,   398,  -493,  -493,  -493,
    -493,   143,   365,  -493,   390,   396,   397,   399,   400,   401,
     402,   403,    14,   262,  -493,   406,   378,   407,   408,   409,
     405,   411,   413,   414,   415,   416,   -91,   417,   418,   412,
     404,   404,   419,   410,   429,   434,   436,   376,   -80,  -493,
     420,  -493,   421,  -493,   440,   441,   443,  -493,  -493,  -493,
    -493,   444,  -493,   445,   425,   446,   430,   431,   432,  -493,
     433,   105,   426,  -493,   435,   437,   438,   439,   452,   442,
     455,   447,  -493,   -89,   -12,  -493,  -493,   103,  -493,   128,
    -493,   204,   448,   205,   423,   321,   445,   206,  -493,   421,
     421,  -493,  -493,   450,   451,   453,   454,   -35,  -493,   457,
    -493,  -493,  -493,   456,  -493,    25,    18,  -493,  -493,  -493,
    -493,   458,  -493,   459,  -493,   460,   461,   463,  -493,   462,
    -493,   464,  -493,   468,   436,  -493,   471,  -493,  -493,   210,
    -493,   474,   421,    -3,    95,   465,   466,   467,   469,   470,
     472,   404,   105,   473,  -493,   477,   475,  -493,  -493,  -493,
    -493,  -493,  -493,    98,   476,   482,  -493,  -493,   487,   486,
     492,   478,   436,  -493,  -493,    95,    95,   191,  -493,  -493,
     146,  -493,  -493,  -493,  -493,  -493,  -493,   122,   129,   479,
     480,  -493,  -493,   436,  -493,   481,  -493,   483,   436,   100,
     -32,  -493,   -16,   121,    95,    95,   105,   105,   105,   105,
     105,   485,  -493,   105,  -493,   490,   123,   100,  -493,   100,
     -32,   484,   491,  -493,   494,   488,   498,  -493,  -493,  -493,
     208,   172,   208,   180,   208,   499,   195,  -493,  -493,   -31,
     489,   493,   501,   503,   100,   100,   495,   105,   105,   105,
     105,   500,  -493,  -493,   503,   100,   497,  -493,   436,  -493,
     496,  -493,   208,   208,   208,   208,   502,   436,   504,  -493,
     -25,   510,  -493,   -25,   510,  -493,   511,   518,   519,   522,
     505,   506,   507,   508,  -493,  -493,  -493,  -493
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     4,     5,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     8,
       0,     0,   108,     0,     0,    15,     1,     3,     0,     0,
     175,   177,     0,     0,     0,     0,     0,     0,   106,   107,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     7,
       0,   111,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    60,    62,
     176,   182,     0,     0,     0,     0,     0,    63,    64,    65,
      66,    70,    67,    68,    69,    71,    72,    73,    74,    75,
      76,     0,    78,    79,    80,    81,    89,    82,    90,    91,
      92,    93,    94,    95,    96,    83,    84,    85,    86,    87,
      88,    97,    98,    99,   100,   101,   102,   103,   104,   105,
       0,     0,     0,    61,     0,     9,    13,     0,    30,     0,
       0,     0,    35,     0,     0,    52,     0,     0,     0,     0,
       0,     0,     0,    44,    28,     0,    21,    20,     0,    10,
       0,     0,     0,   183,   180,   181,   178,   179,    77,     0,
      54,   109,     0,     0,     0,     0,     0,   114,   112,   113,
     115,     0,   142,   131,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   130,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   110,
     142,   142,   138,    24,     0,     0,     0,    50,    49,    23,
      22,     0,    38,     0,     0,     0,     0,     0,     0,    33,
       0,     0,     0,   150,     0,     0,     0,     0,     0,     0,
       0,     0,    58,     0,     0,    19,   121,     0,   123,     0,
     125,     0,   127,     0,     0,     0,     0,     0,   142,   136,
     139,   153,   141,     0,     0,     0,     0,     0,    26,     0,
      40,    32,    51,     0,    27,     0,     0,    36,    31,    39,
      46,     0,    25,     0,    12,     0,     0,     0,   117,     0,
     118,     0,   119,     0,     0,   116,     0,   153,   153,     0,
     133,     0,   137,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   149,     0,     0,    16,    59,    18,
     120,   122,   124,     0,   126,     0,   134,   132,     0,     0,
      53,     0,     0,   173,   174,     0,     0,   154,   160,   163,
       0,    42,    43,    37,    41,    14,    29,     0,     0,     0,
       0,    11,   129,     0,    57,     0,   153,     0,     0,     0,
       0,   158,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   151,     0,    48,     0,     0,     0,   135,     0,
       0,     0,   155,   162,    53,     0,     0,   159,   156,   157,
     170,   171,   172,   168,   169,     0,     0,    45,   128,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,   140,     0,     0,     0,    56,     0,   161,
       0,   145,   164,   166,   165,   167,     0,     0,     0,   148,
       0,     0,    34,     0,     0,    55,     0,     0,     0,     0,
       0,     0,     0,     0,   144,   143,   147,   146
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -493,  -493,  -493,   337,  -493,  -493,  -493,  -493,  -493,  -398,
    -493,  -492,  -446,  -493,  -320,  -493,   -53,  -493,  -493,  -493,
    -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -407,  -493,
    -493,  -313,  -493,    93,  -311,  -493,  -493,   -10,  -412,  -493,
    -445,  -360,  -455,  -406,  -493,   -57
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    50,    51,    52,   303,   186,   187,   393,   258,   451,
     281,   506,   452,   475,   363,    53,   120,    54,   161,   241,
     242,   287,   288,   289,   290,   367,   369,   371,   373,   164,
     329,   377,   291,   292,   332,   382,   352,   353,   423,   424,
     501,   457,   502,   503,   459,   460
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     114,   364,   449,   478,   294,   445,   446,   443,   522,   121,
     122,   123,   124,   125,   126,   127,   128,   375,   458,   379,
     380,   134,   357,   136,   405,   268,   103,   358,   269,   406,
     387,   148,   145,   146,   147,    55,   149,   150,   151,   152,
     153,   154,   519,   376,   157,   480,   162,   104,   105,   458,
     458,   477,   295,   296,   520,   191,   192,   297,   556,   557,
     298,   558,   559,   419,   498,   504,   496,   422,   299,   539,
     524,   500,   555,   300,   301,   247,    56,   538,   458,   458,
     540,   302,   505,   421,   484,   485,   416,   429,   547,   248,
     548,   533,    57,   416,   450,   481,   482,   507,   -17,   165,
     166,   407,   521,   167,   168,   169,   406,   170,   171,    58,
     172,   467,   173,   174,   175,   433,   176,   177,   178,   179,
     180,   181,   182,   183,   508,   509,   341,   184,   185,   342,
     351,   550,   193,   194,   195,   196,   274,   275,   276,   277,
     553,     1,    59,   432,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,   279,   453,   454,
      60,   110,   111,   453,   454,   244,   110,   111,   129,   118,
     119,   110,   111,   112,    45,    61,   455,   456,   112,   245,
     130,   246,   113,   112,    46,    47,   416,   113,   408,    99,
     472,   409,    48,   486,   487,   488,   489,   490,   193,   194,
     195,   196,   328,   286,   273,    49,   193,   194,   195,   196,
     406,   416,   492,   410,   491,   518,   411,   493,   486,   487,
     488,   489,   490,   193,   194,   195,   196,   193,   194,   195,
     196,   193,   194,   195,   196,   197,   195,   196,    62,   229,
     193,   194,   195,   196,    63,   527,    64,   528,   243,   193,
     194,   195,   196,   529,    65,   530,    66,   193,   194,   195,
     196,   484,   485,    67,   395,   193,   194,   195,   196,    68,
      69,   273,   193,   194,   195,   196,    70,   106,   532,   282,
     283,   284,   285,    71,   286,   193,   194,   195,   196,   412,
     415,   420,   413,   416,   421,   447,   190,    72,   421,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
     100,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,   101,   102,   108,   109,
     115,   116,   117,   131,   132,   133,   135,   137,   138,   139,
     140,   141,   142,   143,   144,   468,   155,   156,   158,   323,
     160,   163,   324,   343,   330,   272,   434,     0,   107,   271,
       0,     0,     0,     0,   159,     0,   211,     0,     0,   483,
     188,   189,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   280,   212,   213,   214,   215,
     216,   217,   418,   218,   219,   220,   221,   222,   223,   510,
     511,   512,   513,   514,   224,   225,   516,   226,   227,   228,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     249,   250,   251,   240,   253,   254,   252,   256,   257,   255,
     259,   260,   261,   262,   293,   304,   265,   263,   264,   305,
     542,   543,   544,   545,   266,   267,   270,   278,   306,   307,
     331,   309,   308,   311,   310,   312,   313,   314,   315,   316,
     317,   320,   321,   318,   319,   327,   345,   325,   326,   374,
     322,   362,     0,     0,     0,   333,     0,   366,   334,   335,
       0,   336,     0,   381,   417,   337,   338,   339,   340,   344,
     346,   347,   348,   349,   350,   351,   368,   354,   355,   356,
     359,   370,   361,   372,   365,   378,   360,   383,   384,   385,
     388,   386,   375,   389,   396,   390,   391,   392,   394,   401,
     397,   403,   398,   399,   400,     0,     0,   402,   438,   440,
       0,   441,   404,   425,   426,   442,   427,   428,   444,   414,
     430,   448,   436,   470,     0,   437,   435,   431,   439,   474,
     461,   462,   463,   450,   464,   465,   469,   466,   476,   -56,
     471,   -55,   524,   495,   494,   526,   531,   473,   536,   479,
     537,     0,   497,   515,   499,   517,   523,   555,   560,   525,
     541,   534,   549,   546,   535,   561,   562,   552,   551,   563,
     564,   565,   566,   567,     0,     0,   554
};

static const yytype_int16 yycheck[] =
{
      57,   321,     5,   449,     4,   417,   418,   414,   500,    62,
      63,    64,    65,    66,    67,    68,    69,    97,   424,   330,
     331,    74,   113,    76,   113,   112,    95,   118,   115,   118,
     343,    88,    85,    86,    87,   116,    89,    90,    91,    92,
      93,    94,   497,   123,    97,   452,   103,   116,   117,   455,
     456,   449,    52,    53,   499,   112,   113,    57,   550,   551,
      60,   553,   554,   376,   476,    97,   473,   378,    68,   524,
     101,   478,    97,    73,    74,   101,   116,   523,   484,   485,
     525,    81,   480,   118,   100,   101,   118,   122,   534,   115,
     535,   122,   116,   118,    97,   455,   456,   113,    49,    50,
      51,   113,   500,    54,    55,    56,   118,    58,    59,   116,
      61,   431,    63,    64,    65,    97,    67,    68,    69,    70,
      71,    72,    73,    74,   484,   485,   112,    78,    79,   115,
     112,   538,   107,   108,   109,   110,   193,   194,   195,   196,
     547,     3,   116,   118,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,   240,    93,    94,
     116,    96,    97,    93,    94,   101,    96,    97,    96,    93,
      94,    96,    97,   108,    66,   116,   111,   112,   108,   115,
     108,   117,   112,   108,    76,    77,   118,   112,   115,   115,
     122,   118,    84,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    89,    90,   113,    97,   107,   108,   109,   110,
     118,   118,   113,   115,   122,   122,   118,   118,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   107,   108,   109,
     110,   107,   108,   109,   110,   115,   109,   110,   116,   115,
     107,   108,   109,   110,   116,   103,   116,   105,   115,   107,
     108,   109,   110,   103,   116,   105,   116,   107,   108,   109,
     110,   100,   101,   116,   351,   107,   108,   109,   110,   116,
     116,   113,   107,   108,   109,   110,   116,     0,   113,    85,
      86,    87,    88,   116,    90,   107,   108,   109,   110,   115,
     115,   115,   118,   118,   118,   115,   114,   116,   118,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
      99,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   112,    97,    97,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,   432,    96,    96,    96,   123,
      97,    97,   123,   121,   291,    49,   396,    -1,    51,    75,
      -1,    -1,    -1,    -1,   115,    -1,    96,    -1,    -1,   456,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,    97,   115,   115,   115,   115,
     115,   115,   101,   115,   115,   115,   115,   115,   115,   486,
     487,   488,   489,   490,   115,   115,   493,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     112,   112,   112,   118,   112,   112,   115,   112,   112,   115,
     112,   112,   112,   112,    97,    97,   112,   115,   115,    97,
     527,   528,   529,   530,   115,   115,   119,   115,    97,    97,
     115,    97,    99,    97,    99,   112,    97,    99,    97,    97,
      97,   112,   112,    99,    99,    97,   118,   123,   123,   123,
     113,    97,    -1,    -1,    -1,   115,    -1,    97,   112,   112,
      -1,   112,    -1,    92,    91,   115,   115,   115,   115,   113,
     113,   113,   113,   118,   113,   112,    97,   113,   113,   113,
     113,    97,   120,    97,   115,   115,   118,    97,    97,    96,
     115,    97,    97,    97,   118,   115,   115,   115,   115,    97,
     115,    96,   115,   115,   115,    -1,    -1,   115,    97,    97,
      -1,    97,   115,   113,   113,    97,   113,   113,    97,   121,
     113,    97,   113,    96,    -1,   115,   118,   121,   115,    97,
     115,   115,   115,    97,   115,   115,   113,   115,   101,    97,
     115,    97,   101,   113,   115,    97,    97,   121,    97,   121,
      97,    -1,   121,   118,   121,   115,   122,    97,    97,   121,
     115,   122,   115,   113,   121,    97,    97,   115,   122,    97,
     115,   115,   115,   115,    -1,    -1,   122
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    66,    76,    77,    84,    97,
     125,   126,   127,   139,   141,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   115,
      99,   112,    97,    95,   116,   117,     0,   127,    97,    96,
      96,    97,   108,   112,   169,    96,    96,    96,    93,    94,
     140,   140,   140,   140,   140,   140,   140,   140,   140,    96,
     108,    96,    96,    96,   140,    96,   140,    96,    96,    96,
      96,    96,    96,    96,    96,   140,   140,   140,   169,   140,
     140,   140,   140,   140,   140,    96,    96,   140,    96,   115,
      97,   142,   169,    97,   153,    50,    51,    54,    55,    56,
      58,    59,    61,    63,    64,    65,    67,    68,    69,    70,
      71,    72,    73,    74,    78,    79,   129,   130,   115,   115,
     114,   169,   169,   107,   108,   109,   110,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,    96,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     118,   143,   144,   115,   101,   115,   117,   101,   115,   112,
     112,   112,   115,   112,   112,   115,   112,   112,   132,   112,
     112,   112,   112,   115,   115,   112,   115,   115,   112,   115,
     119,    75,    49,   113,   169,   169,   169,   169,   115,   140,
      97,   134,    85,    86,    87,    88,    90,   145,   146,   147,
     148,   156,   157,    97,     4,    52,    53,    57,    60,    68,
      73,    74,    81,   128,    97,    97,    97,    97,    99,    97,
      99,    97,   112,    97,    99,    97,    97,    97,    99,    99,
     112,   112,   113,   123,   123,   123,   123,    97,    89,   154,
     157,   115,   158,   115,   112,   112,   112,   115,   115,   115,
     115,   112,   115,   121,   113,   118,   113,   113,   113,   118,
     113,   112,   160,   161,   113,   113,   113,   113,   118,   113,
     118,   120,    97,   138,   138,   115,    97,   149,    97,   150,
      97,   151,    97,   152,   123,    97,   123,   155,   115,   158,
     158,    92,   159,    97,    97,    96,    97,   155,   115,    97,
     115,   115,   115,   131,   115,   169,   118,   115,   115,   115,
     115,    97,   115,    96,   115,   113,   118,   113,   115,   118,
     115,   118,   115,   118,   121,   115,   118,    91,   101,   155,
     115,   118,   158,   162,   163,   113,   113,   113,   113,   122,
     113,   121,   118,    97,   161,   118,   113,   115,    97,   115,
      97,    97,    97,   152,    97,   162,   162,   115,    97,     5,
      97,   133,   136,    93,    94,   111,   112,   165,   167,   168,
     169,   115,   115,   115,   115,   115,   115,   138,   169,   113,
      96,   115,   122,   121,    97,   137,   101,   133,   136,   121,
     152,   165,   165,   169,   100,   101,   102,   103,   104,   105,
     106,   122,   113,   118,   115,   113,   152,   121,   162,   121,
     152,   164,   166,   167,    97,   133,   135,   113,   165,   165,
     169,   169,   169,   169,   169,   118,   169,   115,   122,   166,
     164,   133,   135,   122,   101,   121,    97,   103,   105,   103,
     105,    97,   113,   122,   122,   121,    97,    97,   136,   166,
     164,   115,   169,   169,   169,   169,   113,   136,   164,   115,
     152,   122,   115,   152,   122,    97,   135,   135,   135,   135,
      97,    97,    97,    97,   115,   115,   115,   115
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   124,   125,   126,   126,   127,   127,   127,   127,   127,
     127,   127,   127,   128,   127,   129,   127,   130,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   131,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   132,   127,   127,
     127,   127,   127,   133,   134,   135,   136,   137,   138,   138,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   140,   140,   142,   141,
     143,   144,   144,   144,   144,   144,   145,   146,   147,   148,
     149,   149,   150,   150,   151,   151,   152,   152,   152,   152,
     153,   153,   154,   154,   155,   155,   156,   156,   156,   156,
     157,   158,   158,   159,   159,   159,   159,   159,   159,   160,
     160,   161,   161,   163,   162,   164,   165,   165,   165,   165,
     165,   166,   166,   167,   167,   167,   167,   167,   168,   168,
     168,   168,   168,   168,   168,   169,   169,   169,   169,   169,
     169,   169,   169,   169
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     3,     2,     4,
       4,     9,     7,     0,     9,     0,     8,     0,     8,     7,
       4,     4,     6,     6,     6,     7,     7,     7,     4,     9,
       4,     7,     7,     0,    14,     4,     7,     9,     6,     7,
       7,     9,     9,     9,     4,    11,     7,     0,    10,     6,
       6,     7,     4,     1,     1,     1,     1,     1,     1,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     5,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     1,     1,     0,     5,
       3,     0,     2,     2,     2,     2,     4,     4,     4,     4,
       3,     1,     3,     1,     3,     1,     3,     1,     6,     4,
       3,     3,     4,     3,     3,     5,     3,     4,     2,     3,
       9,     2,     0,    11,    11,     7,    12,    12,     8,     3,
       1,     5,     7,     0,     2,     1,     3,     3,     2,     3,
       1,     3,     1,     1,     5,     5,     5,     5,     3,     3,
       3,     3,     3,     1,     1,     1,     2,     1,     3,     3,
       3,     3,     2,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 317 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { cout << *((yyvsp[-1].mystring)) << endl; }
#line 1958 "parser.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 319 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { cout << "Automata in memory:" << endl;
      for (const auto& p : paut_map) {
        cout << p.first << " ";
        cout << "(" << (p.second)->name << "):";
        p.second->print_size();
      }
      cout << endl << "Constants in memory:" << endl;
      for (const auto& p : rae_map) {
        cout << p.first << " := " << p.second << endl;
      }
      cout << endl << "Symbolic states in memory:" << endl;
      for (const auto& p : ss_map) {
        cout << p.first << " : " << p.second.first.size() << " locs, "
             << p.second.first.get_memory() << " bytes" << endl;
      }
      cout << endl;
    }
#line 1980 "parser.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 341 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-3].mystring));
      const auto& id = *((yyvsp[-1].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        ss_map[dst] = ss_map[id];
      } else if (paut_map.find(id) != paut_map.end()) {
        paut = new automaton(*paut_map[id]);
        paut->name = dst;
        paut_map[dst].reset(paut);
      } else
        yyerror("Identifier " + id + " not found.");
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].mystring);
    }
#line 1999 "parser.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 356 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        if (ss_map[id].second != nullptr) {
          cout << id << " = "
               << ss_map[id].second->name << ".";
          if (ss_map[id].first.empty())
            cout << "{};" << endl;
          else {
            cout << "{" << endl;
            ss_map[id].first.print_phaver(cout);
            cout << endl << "};" << endl;
          }
        } else
          ss_map[id].first.print_phaver(cout);
      } else if (paut_map.find(id) != paut_map.end()) {
        paut_map[id]->print_phaver(cout);
        // paut_map[id]->print();
      } else
        yyerror("Identifier " + id + " not found.");
      delete (yyvsp[-3].mystring);
    }
#line 2026 "parser.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 379 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-8].mystring));
      const auto& fname = *((yyvsp[-4].mystring));
      int format = atoi_consume((yyvsp[-2].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        if (format == 1) // constraint form
          ss_map[id].first.print_con_fp_raw(file_out);
        else if (format == 2) // generator form
          ss_map[id].first.print_gen_fp_raw(file_out);
        else if (format == 3) // debug form
          ss_map[id].first.print();
        else if (format == 4) // debug form
          ss_map[id].first.print(ss_map[id].second->get_loc_names());
        else {
          file_out << id << " = "
                   << ss_map[id].second->name << ".";
          if (ss_map[id].first.empty())
            file_out << "{};" << endl;
          else {
            file_out << "{" << endl;
            ss_map[id].first.print_phaver(file_out);
            file_out << endl << "};";
          }
        }
        file_out.close();
      } else if (paut_map.find(id) != paut_map.end()) {
        file_out.open(fname);
        if (format == 1) // dot form (graphviz)
          paut_map[id]->print_dot(file_out);
        else
          paut_map[id]->print_phaver(file_out);
        file_out.close();
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-4].mystring);
    }
#line 2070 "parser.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 419 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& fname = *((yyvsp[-2].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        clock_val_set temp_cvs = ss_map[id].first.union_over_locations();
        temp_cvs.print_con_fp_raw(file_out);
        file_out.close();
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2089 "parser.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 437 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else
        yyerror("Automaton '" + id + "' not found.");
    }
#line 2101 "parser.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 445 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& states = *((yyvsp[-2].symb_state));
      ss_map[dst] = make_pair(std::move(states), paut);
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].symb_state);
    }
#line 2114 "parser.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 454 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        psymb_state = &ss_map[id].first;
        paut = ss_map[id].second;
      } else {
        yyerror("Unknown state identifier '" + id +"'.");
        psymb_state = nullptr;
      }
    }
#line 2129 "parser.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 465 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-7].mystring));
      if ((yyvsp[-2].vrs) != nullptr) {
        if (ss_map.find(id) != ss_map.end())
          ss_map[id].first.remove_space_dimensions(*(yyvsp[-2].vrs));
        else
          yyerror("Unknown identifier '" + id +"'.");
      }
      psymb_state = nullptr;
      delete (yyvsp[-7].mystring);
      delete (yyvsp[-2].vrs);
    }
#line 2146 "parser.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 478 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        psymb_state = &ss_map[id].first;
        paut = ss_map[id].second;
      } else
        yyerror("Unknown symbolic state identifier '" + id +"'.");
      delete (yyvsp[-1].mystring);
    }
#line 2160 "parser.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 488 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if ((yyvsp[-2].vrs) != nullptr) {
        assert(psymb_state != nullptr);
        psymb_state->project_to_vars(*(yyvsp[-2].vrs));
      }
      psymb_state = nullptr;
      paut = nullptr;
      delete (yyvsp[-2].vrs);
    }
#line 2174 "parser.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 498 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-4].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto sstates = ss_map[id].first;
        const var_ref_set& vrs = ss_map[id].second->parameters;
        auto dim = ss_map[id].second->dim;
        sstates.remove_space_dimensions(vrs.range_complement(0, dim));
        clock_val_set tmp;
        if ((yyvsp[-2].mybool)) {
          cout << "Parameters in any of the locations:" << endl;
          tmp = sstates.union_over_locations();
        } else {
          cout << "Parameters common to all locations:" << endl;
          tmp = sstates.intersection_over_locations();
        }
        tmp.print();
      }
      else
        yyerror("Identifier " + id + " not found.");
      delete (yyvsp[-4].mystring);
    }
#line 2200 "parser.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 520 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        const auto& mycvs = ss_map[id].first.union_over_locations();
        mycvs.print(ss_map[id].first.var_names);
        mycvs.print_gen_fp_raw(cout);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-3].mystring);
    }
#line 2215 "parser.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 531 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        const auto& mycvs = ss_map[id].first.intersection_over_locations();
        mycvs.print(ss_map[id].first.var_names);
        mycvs.print_gen_fp_raw(cout);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-3].mystring);
    }
#line 2230 "parser.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 542 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto mycvs = ss_map[id].first.union_over_locations();
        symb_states_type ss(ss_map[id].first.var_names);
        ss.add("$", std::move(mycvs));
        ss_map[dst] = make_pair(std::move(ss), ss_map[id].second);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2248 "parser.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 556 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto mycvs = ss_map[id].first.intersection_over_locations();
        symb_states_type ss(ss_map[id].first.var_names);
        ss.add("$", std::move(mycvs));
        ss_map[dst] = make_pair(std::move(ss), ss_map[id].second);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2266 "parser.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 570 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto sstates = ss_map[id].first.merge_splitted();
        ss_map[dst] = make_pair(std::move(sstates), nullptr);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2282 "parser.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 582 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-6].mystring));
      const auto& id2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id1) != ss_map.end()) {
        if (ss_map.find(id2) != ss_map.end())
          ss_map[id1].first.intersection_assign(ss_map[id2].first);
        else
          yyerror("Unknown identifier '" + id2 +"'.");
      } else
        yyerror("Unknown identifier '" + id1 +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2300 "parser.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 596 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-6].mystring));
      const auto& id2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id1) != ss_map.end()) {
        if (ss_map.find(id2) != ss_map.end())
          ss_map[id1].first.difference_assign(ss_map[id2].first);
        else
          yyerror("Unknown identifier '" + id2 +"'.");
      } else
        yyerror("Unknown identifier '" + id1 +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2318 "parser.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 610 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-6].mystring));
      const auto& id2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id1) != ss_map.end()) {
        if (ss_map.find(id2) != ss_map.end()) {
          if (ss_map[id1].first.contains(ss_map[id2].first))
            cout << id1 << " contains " << id2 << endl;
          else
            cout << id1 << " does not contain " << id2 << endl;
        } else
          yyerror("Unknown identifier '" + id2 +"'.");
      } else
        yyerror("Unknown identifier '" + id1 +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2339 "parser.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 627 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        if (ss_map[id].first.is_empty())
          cout << "empty" << endl;
        else
          cout << "not empty" << endl;
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-3].mystring);
    }
#line 2355 "parser.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 639 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-8].mystring));
      const auto& name1 = *((yyvsp[-4].mystring));
      const auto& name2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        ss_map[id].first.rename_variable(name1, name2);
        // remove the reference to any automaton because now it's changed
        ss_map[id].second = nullptr;
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-4].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2374 "parser.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 657 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& comp_name = *((yyvsp[-3].mystring));
      const auto& aut_names = *((yyvsp[-1].ident_list));
      assert(!aut_names.empty());
      bool first = true;
      for (const auto& aut_name : aut_names) {
        const auto iter = paut_map.find(aut_name);
        if (iter == paut_map.end())
          yyerror("Automaton '" + aut_name + "' not found.");
        assert(iter->second != nullptr);
        const automaton& aut = *(iter->second);
        if (first) {
          paut = new automaton(aut);
          first = false;
          continue;
        }
        automaton* pcomp = new automaton();
        compose_discrete(*pcomp, *paut, aut);
        std::swap(paut, pcomp);
        delete pcomp;
      }
      paut->name = comp_name;
      paut_map[comp_name].reset(paut);
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].ident_list);
    }
#line 2405 "parser.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 684 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& fname = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        paut_map[id]->print_inv_fp_raw(file_out);
        file_out.close();
      } else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2423 "parser.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 698 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& fname = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        paut_map[id]->print_surface_fp_raw(file_out);
        file_out.close();
      }	else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2441 "parser.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 712 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-5].mystring));
      psymb_state = nullptr;
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else
        yyerror("Automaton '" + id + "' not found.");
    }
#line 2454 "parser.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 721 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-13].mystring));
      const auto& fname = *((yyvsp[-9].mystring));
      const auto& var_list = *((yyvsp[-5].vrs));
      const auto& id2 = *((yyvsp[-2].mystring));
      psymb_state = nullptr;
      if (paut_map.find(id) != paut_map.end()) {
        paut = paut_map[id].get();
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        if (ss_map.find(id2) != ss_map.end())
          paut->print_graph(file_out, var_list, ss_map[id2].first);
        else
          yyerror("Unknown identifier '" + id2 + "'.");
        file_out.close();
      } else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-13].mystring);
      delete (yyvsp[-9].mystring);
      delete (yyvsp[-5].vrs);
      delete (yyvsp[-2].mystring);
    }
#line 2481 "parser.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 744 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut_map[id]->reverse();
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-3].mystring);
    }
#line 2494 "parser.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 753 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& lab = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut_map[id]->add_label(lab);
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2509 "parser.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 764 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      int delta = atoi_consume((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_reach_set_forwarditer(delta),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
    }
#line 2526 "parser.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 777 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_reach_set(),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2542 "parser.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 789 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& id_init = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(id_init) != ss_map.end())
          paut->ini_states_assign(ss_map[id_init].first);
        else
          yyerror("Unknown identifier '" + id_init +"'.");
      }
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2565 "parser.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 808 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& id_inv = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(id_inv) != ss_map.end())
          paut->invariant_assign(ss_map[id_inv].first);
        else
          yyerror("Unknown identifier '" + id_inv +"'.");
      }
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2588 "parser.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 827 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      const auto& id_ini = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(id_ini) != ss_map.end()) {
          symb_states_type dummystates;
          bool dummybool;
          ss_map[dst] = make_pair(paut->get_reach_set(ss_map[id_ini].first,
                                                      dummystates, dummybool),
                                  paut);
        }
        else
          yyerror("Unknown identifier '" + id_ini +"'.");
      }
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2618 "parser.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 853 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      const auto& target = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(target) != ss_map.end()) {
          symb_states_type sstates;
          if (paut->is_reachable(ss_map[target].first, sstates))
            cout << target << " is reachable." << endl;
          else
            cout << target << " not reachable." << endl;
          ss_map[dst] = make_pair(std::move(sstates), paut);
        }
        else
          yyerror("Unknown identifier '" + target +"'.");
      }
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2649 "parser.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 880 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      const auto& target = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(target) != ss_map.end()) {
          symb_states_type sstates;
          if (paut->is_reachable_fb(ss_map[target].first, sstates))
            cout << target << " is reachable." << endl;
          else
            cout << target << " not reachable." << endl;
          ss_map[dst] = make_pair(std::move(sstates), paut);
        }
        else
          yyerror("Unknown identifier '" + target +"'.");
      }
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2680 "parser.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 907 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      refine_loc_deriv(*paut_map[id]);
      delete (yyvsp[-3].mystring);
    }
#line 2690 "parser.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 913 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-10].mystring));
      const auto& label = *((yyvsp[-6].mystring));
      const auto& method = *((yyvsp[-4].mystring));
      refinement_method ref_meth;
      if (method == "carth_center")
        ref_meth = carth_center;
      else if (method == "carth0_center")
        ref_meth = carth0_center;
      else if (method == "carth1_center")
        ref_meth = carth1_center;
      else if (method == "deriv_center")
        ref_meth = deriv_center;
      else if (method == "jacob_center")
        ref_meth = jacob_center;
      else if (method == "deriv_dcenter")
        ref_meth = deriv_dcenter;
      else if (method == "jacob_dcenter")
        ref_meth = jacob_dcenter;
      else {
        ref_meth = carth_center;
        yyerror("Unknown refinement method '" + method + "'.");
      }
      paut = paut_map[id].get();
      refine_locs(*paut, paut->get_label_ref(label),
                  ref_meth, atoi_consume((yyvsp[-2].mystring)));
      delete (yyvsp[-10].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-4].mystring);
    }
#line 2725 "parser.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 944 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& state = *((yyvsp[-2].mystring));
      paut = paut_map[id].get();
      refine_states(*paut, ss_map[state].first);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2738 "parser.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 953 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-2].mystring));
      paut = paut_map[id].get();
    }
#line 2747 "parser.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 958 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& label = *((yyvsp[-2].mystring));
      REFINEMENT_CONS = *((yyvsp[-4].refinement_cons));
      REFINEMENT_LABEL = paut->get_label_ref(label);
      delete (yyvsp[-9].mystring);
      delete (yyvsp[-4].refinement_cons);
      delete (yyvsp[-2].mystring);
    }
#line 2760 "parser.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 967 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_ini_states(),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2776 "parser.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 979 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_invariants(),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2792 "parser.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 992 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& state = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end()) {
        if (ss_map.find(state) != ss_map.end())
          paut_map[id]->unlock_surface_locations(ss_map[state].first);
        else
          yyerror("Unknown identifier '" + state +"'.");
      } else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2810 "parser.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 1006 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut_map[id]->unlock_locations();
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-3].mystring);
    }
#line 2823 "parser.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 1022 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "do"); }
#line 2829 "parser.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 1024 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "end"); }
#line 2835 "parser.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 1026 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "goto"); }
#line 2841 "parser.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 1028 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "sync"); }
#line 2847 "parser.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 1030 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "wait"); }
#line 2853 "parser.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 1034 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (psymb_state != nullptr) {
        auto pvrs = new var_ref_set;
        if (psymb_state->var_names.contains_name(id)) {
          pvrs->insert(psymb_state->var_names.get_id(id));
          (yyval.vrs) = pvrs;
        } else {
          yyerror("Unknown state variable '" + id +"'.");
          delete pvrs;
          (yyval.vrs) = nullptr;
        }
      } else if (paut != nullptr) {
        auto pvrs = new var_ref_set;
        if (paut->var_id_map.contains_name(id)) {
          pvrs->insert(paut->var_id_map.get_id(id));
          (yyval.vrs) = pvrs;
        } else {
          yyerror("Unknown automaton variable '" + id +"'.");
          delete pvrs;
          (yyval.vrs) = nullptr;
        }
      } else
        yyerror("Don't know which set of states '"
                + id +"' refers to.");
      delete (yyvsp[0].mystring);
    }
#line 2885 "parser.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 1062 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (psymb_state != nullptr) {
        if (psymb_state->var_names.contains_name(id)) {
          (yyvsp[-2].vrs)->insert(psymb_state->var_names.get_id(id));
          (yyval.vrs) = (yyvsp[-2].vrs);
        } else
          yyerror("Unknown state variable '" + id +"'.");
      }	else if (paut != nullptr) {
        if (paut->var_id_map.contains_name(id)) {
          (yyvsp[-2].vrs)->insert(paut->var_id_map.get_id(id));
          (yyval.vrs) = (yyvsp[-2].vrs);
        } else
          yyerror("Unknown automaton variable '" + id +"'.");
      } else
        yyerror("Don't know which set of states '"
                + id +"' refers to.");
      delete (yyvsp[0].mystring);
    }
#line 2909 "parser.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 1085 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (!set_poly_kind(id, true))
        yyerror("Invalid poly kind name");
      delete (yyvsp[-1].mystring);
    }
#line 2920 "parser.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 1092 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      const auto& rae = *((yyvsp[-1].rae));
      rae_map[id] = rae;
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].rae);
    }
#line 2932 "parser.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 1101 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TIME_POST_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 2938 "parser.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 1103 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      TIME_POST_CONE_LAMBDA= (yyvsp[-1].rae)->rat_inhomo_term();
      delete (yyvsp[-1].rae);
    }
#line 2947 "parser.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 1108 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TIME_POST_CONE_WIDEN_DELAY = atoi_consume((yyvsp[-1].mystring)); }
#line 2953 "parser.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 1110 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TIME_POST_CONE_WIDEN_PRECISION = atoi_consume((yyvsp[-1].mystring)); }
#line 2959 "parser.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 1112 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { MEMORY_MODE = atoi_consume((yyvsp[-1].mystring)); }
#line 2965 "parser.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 1115 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { PARSER_FIX_DPOST=(yyvsp[-1].mybool); }
#line 2971 "parser.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 1118 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CHEAP_CONTAINS=(yyvsp[-1].mybool); }
#line 2977 "parser.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 1120 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CHEAP_CONTAINS_USE_BBOX=(yyvsp[-1].mybool); }
#line 2983 "parser.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 1122 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { MAINTAIN_BOXED_CCVS=(yyvsp[-1].mybool); }
#line 2989 "parser.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 1124 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_BBOX=(yyvsp[-1].mybool); }
#line 2995 "parser.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 1126 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_CONSTRAINT_HULL=(yyvsp[-1].mybool); }
#line 3001 "parser.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 1128 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_CONVEX_HULL=(yyvsp[-1].mybool); }
#line 3007 "parser.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 1130 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_TIME_ELAPSE = (yyvsp[-1].mybool); }
#line 3013 "parser.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 1132 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_STOP_AT_FORB=(yyvsp[-1].mybool); }
#line 3019 "parser.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 1134 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_MAX_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 3025 "parser.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 1136 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_MAX_ITER = - atoi_consume((yyvsp[-1].mystring)); }
#line 3031 "parser.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 1138 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_REPORT_INTERVAL = atoi_consume((yyvsp[-1].mystring)); }
#line 3037 "parser.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 1140 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_BBOX_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 3043 "parser.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 1142 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_STOP_USE_CONVEX_HULL_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 3049 "parser.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 1144 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_STOP_USE_CONVEX_HULL_SETTLE=(yyvsp[-1].mybool); }
#line 3055 "parser.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 1146 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { LIMIT_CONSTRAINTS_METHOD=(yyvsp[-1].mybool); }
#line 3061 "parser.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 1148 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_DERIVATIVE_METHOD = atoi_consume((yyvsp[-1].mystring)); }
#line 3067 "parser.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 1150 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_PRIORITIZE_REACH_SPLIT=(yyvsp[-1].mybool); }
#line 3073 "parser.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 1152 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_SMALLEST_FIRST=(yyvsp[-1].mybool); }
#line 3079 "parser.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 1154 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_USE_FP=(yyvsp[-1].mybool); }
#line 3085 "parser.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 1156 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      mpq_class q = (yyvsp[-1].rae)->rat_inhomo_term();
      REFINE_DERIV_MINANGLE = q.get_d();
      delete (yyvsp[-1].rae);
    }
#line 3095 "parser.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 1162 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_PRIORITIZE_ANGLE=(yyvsp[-1].mybool); }
#line 3101 "parser.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 1164 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CONSTRAINT_LIMIT = atoi_consume((yyvsp[-1].mystring)); }
#line 3107 "parser.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 1166 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TP_CONSTRAINT_LIMIT = atoi_consume((yyvsp[-1].mystring)); }
#line 3113 "parser.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 1168 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CONSTRAINT_TRIGGER = atoi_consume((yyvsp[-1].mystring)); }
#line 3119 "parser.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 1170 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_BITSIZE_TRIGGER = atoi_consume((yyvsp[-1].mystring)); }
#line 3125 "parser.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 1172 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { CONSTRAINT_BITSIZE = atoi_consume((yyvsp[-1].mystring)); }
#line 3131 "parser.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 1174 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      int sm = atoi_consume((yyvsp[-1].mystring));
      switch (sm) {
      case 0:
        SEARCH_METHOD = Search_Method::trx_based;
        break;
      case 1:
        SEARCH_METHOD = Search_Method::topsort;
        break;
      case 2:
        SEARCH_METHOD = Search_Method::topsort_reachable;
        break;
      default:
        yyerror("Expecting an integer in {0, 1, 2}");
        break;
      }
    }
#line 3153 "parser.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 1192 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { SEARCH_METHOD_TOPSORT_TOKENS = atoi_consume((yyvsp[-1].mystring)); }
#line 3159 "parser.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 1194 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { SNAPSHOT_INTERVAL = atoi_consume((yyvsp[-1].mystring)); }
#line 3165 "parser.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 1197 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TIME_RELEVANCE=(yyvsp[-1].mybool); }
#line 3171 "parser.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 1199 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TIME_RELEVANCE_DURING=(yyvsp[-1].mybool); }
#line 3177 "parser.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 1201 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TIME_RELEVANCE_FINAL=(yyvsp[-1].mybool); }
#line 3183 "parser.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 1203 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TRANS_DIMS=(yyvsp[-1].mybool); }
#line 3189 "parser.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 1205 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_PARTITION_INSIDE=(yyvsp[-1].mybool); }
#line 3195 "parser.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 1207 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_FB_REFINE_METHOD = atoi_consume((yyvsp[-1].mystring)); }
#line 3201 "parser.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 1209 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_MAX_CHECKS = atoi_consume((yyvsp[-1].mystring)); }
#line 3207 "parser.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 1211 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_USE_NEW_SPLIT = (yyvsp[-1].mybool); }
#line 3213 "parser.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 1213 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { pplite::Poly::set_minimize_filter_threshold(atoi_consume((yyvsp[-1].mystring))); }
#line 3219 "parser.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 1217 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.mybool) = true; }
#line 3225 "parser.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 1218 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.mybool) = false; }
#line 3231 "parser.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 1223 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (paut_map.find(id) == paut_map.end()) {
        paut = new automaton(id);
        paut_map[id].reset(paut);
      } else
        yyerror("automaton " + id + " already defined");
      delete (yyvsp[0].mystring);
    }
#line 3245 "parser.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 1233 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      message(32200, "Parsed automaton: "
              + int2string(paut->locations.size()) + " locs, "
              + int2string(paut->transitions.size()) + " trans.");
    }
#line 3255 "parser.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1254 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id_list = *((yyvsp[-1].ident_list));
      if (paut != nullptr) {
        for (const auto& lab : id_list)
          paut->add_label(lab);
      }
      else
        yyerror("synclabs: paut not defined");
      delete (yyvsp[-1].ident_list);
    }
#line 3270 "parser.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1280 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3280 "parser.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1286 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3290 "parser.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1295 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_ext_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3300 "parser.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1301 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_ext_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3310 "parser.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1310 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_parameter(id);
      delete (yyvsp[0].mystring);
    }
#line 3320 "parser.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1316 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_parameter(id);
      delete (yyvsp[0].mystring);
    }
#line 3330 "parser.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1325 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      (yyval.ident_list)->push_back(id);
      delete (yyvsp[0].mystring);
    }
#line 3340 "parser.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1331 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      (yyval.ident_list) = new std::list<string>;
      (yyval.ident_list)->push_back(id);
      delete (yyvsp[0].mystring);
    }
#line 3351 "parser.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 1338 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& prefix = *((yyvsp[-3].mystring));
      auto& id_list = *((yyvsp[-1].ident_list));
      for (auto& s : id_list)
        s.insert(0, prefix);
      (yyval.ident_list)->splice((yyval.ident_list)->end(), id_list);
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].ident_list);
    }
#line 3365 "parser.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 1348 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& prefix = *((yyvsp[-3].mystring));
      auto& id_list = *((yyvsp[-1].ident_list));
      for (auto& s : id_list)
        s.insert(0, prefix);
      (yyval.ident_list) = (yyvsp[-1].ident_list);
      delete (yyvsp[-3].mystring);
    }
#line 3378 "parser.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 1360 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      (yyval.ident_list)->push_back(id);
      delete (yyvsp[0].mystring);
    }
#line 3388 "parser.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 1366 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-2].mystring));
      const auto& id2 = *((yyvsp[0].mystring));
      (yyval.ident_list) = new std::list<string>;
      (yyval.ident_list)->push_back(id1);
      (yyval.ident_list)->push_back(id2);
      delete (yyvsp[-2].mystring);
      delete (yyvsp[0].mystring);
    }
#line 3402 "parser.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1379 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      paut->ini_states_assign(*(yyvsp[-1].symb_state));
      delete (yyvsp[-1].symb_state);
    }
#line 3411 "parser.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1384 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      paut->ini_states_assign(*(yyvsp[-1].symb_state));
      delete (yyvsp[-1].symb_state);
    }
#line 3420 "parser.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 1392 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& loc = *((yyvsp[-2].mystring));
      auto& state = *((yyvsp[0].cvs));
      if (paut != nullptr) {
        psymb_state = new symb_states_type(paut->get_var_names());
        psymb_state->add(loc, std::move(state));
        (yyval.symb_state) = psymb_state;
      }	else
        yyerror("Don't know which automaton to attribute states to.");
      delete (yyvsp[-2].mystring);
      delete (yyvsp[0].cvs);
    }
#line 3437 "parser.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 1405 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& loc = *((yyvsp[-2].mystring));
      auto& state = *((yyvsp[0].cvs));
      if (paut != nullptr) {
        psymb_state->add(loc, std::move(state));
        (yyval.symb_state) = psymb_state;
      }
      else
        yyerror("Don't know which automaton to attribute states to.");
      delete (yyvsp[-2].mystring);
      delete (yyvsp[0].cvs);
    }
#line 3454 "parser.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1428 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-7].mystring));
      const auto& inv = *((yyvsp[-4].cvs));
      auto& cpost = *((yyvsp[-1].con_list));
      swap_space_dims(cpost, 0, paut->dim, paut->dim);
      paut->add_location(std::move(inv), id, std::move(cpost));
      // will serve as the source location for the coming transitions
      current_loc_name = id;
      delete (yyvsp[-7].mystring);
      delete (yyvsp[-4].cvs);
      delete (yyvsp[-1].con_list);
    }
#line 3471 "parser.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 1452 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-9].cvs));
      const auto& id_list = *((yyvsp[-7].ident_list));
      auto& dpost = *((yyvsp[-4].con_list));
      const auto& target = *((yyvsp[-1].mystring));
      maybe_fix_dpost(paut->dim, dpost, paut->variables);
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost);
      delete (yyvsp[-9].cvs);
      delete (yyvsp[-7].ident_list);
      delete (yyvsp[-4].con_list);
      delete (yyvsp[-1].mystring);
    }
#line 3491 "parser.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 1468 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-9].cvs));
      auto& dpost = *((yyvsp[-6].con_list));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      maybe_fix_dpost(paut->dim, dpost, paut->variables);
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost);
      delete (yyvsp[-9].cvs);
      delete (yyvsp[-6].con_list);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3511 "parser.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1484 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-5].cvs));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      // controlled variables should remain constant
      Cons dpost = identity_dpost(paut->dim, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost);
      delete (yyvsp[-5].cvs);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3529 "parser.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1499 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-10].cvs));
      const auto& id_list = *((yyvsp[-7].ident_list));
      auto& dpost = *((yyvsp[-4].con_list));
      const auto& target = *((yyvsp[-1].mystring));
      maybe_fix_dpost(paut->dim, dpost, paut->variables);
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost, Urgency::urgent);
      delete (yyvsp[-10].cvs);
      delete (yyvsp[-7].ident_list);
      delete (yyvsp[-4].con_list);
      delete (yyvsp[-1].mystring);
    }
#line 3549 "parser.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1516 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-10].cvs));
      auto& dpost = *((yyvsp[-6].con_list));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      maybe_fix_dpost(paut->dim, dpost, paut->variables);
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost, Urgency::urgent);
      delete (yyvsp[-10].cvs);
      delete (yyvsp[-6].con_list);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3569 "parser.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1532 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-6].cvs));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      // controlled variables should remain constant
      Cons dpost = identity_dpost(paut->dim, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost, Urgency::urgent);
      delete (yyvsp[-6].cvs);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3587 "parser.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1549 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].refinement_cons)->push_back(*(yyvsp[0].refinement_con));
      (yyval.refinement_cons) = (yyvsp[-2].refinement_cons);
      delete (yyvsp[0].refinement_con);
    }
#line 3597 "parser.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1555 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.refinement_cons) = new RefinementCons;
      (yyval.refinement_cons)->push_back(*(yyvsp[0].refinement_con));
      delete (yyvsp[0].refinement_con);
    }
#line 3607 "parser.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1564 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.refinement_con) = new RefinementCon;
      (yyval.refinement_con)->con = Con((yyvsp[-3].rae)->aexpr.expr, (yyvsp[-3].rae)->aexpr.inhomo,
                    Con::NONSTRICT_INEQUALITY);
      (yyval.refinement_con)->min_d = (yyvsp[-1].rae)->rat_inhomo_term() * Rational((yyvsp[-3].rae)->den);
      (yyval.refinement_con)->max_d = Rational(0);
      delete (yyvsp[-3].rae);
      delete (yyvsp[-1].rae);
    }
#line 3621 "parser.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1574 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.refinement_con) = new RefinementCon;
      (yyval.refinement_con)->con = Con((yyvsp[-5].rae)->aexpr.expr, (yyvsp[-5].rae)->aexpr.inhomo,
                   Con::NONSTRICT_INEQUALITY);
      (yyval.refinement_con)->min_d = (yyvsp[-3].rae)->rat_inhomo_term() * Rational((yyvsp[-5].rae)->den);
      (yyval.refinement_con)->max_d = (yyvsp[-1].rae)->rat_inhomo_term() * Rational((yyvsp[-5].rae)->den);
      delete (yyvsp[-5].rae);
      delete (yyvsp[-3].rae);
      delete (yyvsp[-1].rae);
    }
#line 3636 "parser.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1587 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (paut == nullptr)
        yyerror("paut not defined");
      else
        val_set_dim = paut->dim;
    }
#line 3647 "parser.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1594 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.cvs) = (yyvsp[0].cvs); }
#line 3653 "parser.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1601 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].cvs)->union_assign(*((yyvsp[0].cvs)));
      (yyval.cvs) = (yyvsp[-2].cvs);
      delete (yyvsp[0].cvs);
    }
#line 3663 "parser.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1607 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].cvs)->intersection_assign(*((yyvsp[0].cvs)));
      (yyval.cvs) = (yyvsp[-2].cvs);
      delete (yyvsp[0].cvs);
    }
#line 3673 "parser.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1613 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[0].cvs)->negate();
      (yyval.cvs) = (yyvsp[0].cvs);
    }
#line 3682 "parser.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1618 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.cvs) = (yyvsp[-1].cvs);
    }
#line 3690 "parser.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1622 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& cs = *((yyvsp[0].con_list));
      auto ccvs = convex_clock_val_set(val_set_dim, std::move(cs));
      (yyval.cvs) = new clock_val_set(std::move(ccvs));
      delete (yyvsp[0].con_list);
    }
#line 3701 "parser.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1633 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].con_list)->insert((yyvsp[-2].con_list)->end(),
                 std::make_move_iterator((yyvsp[0].con_list)->begin()),
                 std::make_move_iterator((yyvsp[0].con_list)->end()));
      (yyval.con_list) = (yyvsp[-2].con_list);
      delete (yyvsp[0].con_list);
    }
#line 3713 "parser.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1644 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       (yyval.con_list)->push_back(*(yyvsp[0].con));
       delete (yyvsp[0].con);
     }
#line 3723 "parser.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1650 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3738 "parser.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1661 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3753 "parser.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1672 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3768 "parser.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1683 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3783 "parser.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1698 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::STRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3796 "parser.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1707 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::STRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3809 "parser.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1716 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::NONSTRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3822 "parser.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1725 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::NONSTRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3835 "parser.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1734 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::EQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3848 "parser.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1743 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      auto pcon = new Con(Linear_Expr(), 0, Con::EQUALITY);
      (yyval.con) = pcon;
    }
#line 3857 "parser.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1748 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      auto pcon = new Con(Linear_Expr(), 1, Con::EQUALITY);
      (yyval.con) = pcon;
    }
#line 3866 "parser.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1756 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& str = *((yyvsp[0].mystring));
      auto prae = new Rat_Affine_Expr(str);
      (yyval.rae) = prae;
      delete (yyvsp[0].mystring);
    }
#line 3877 "parser.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1763 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (paut->var_id_map.contains_name(id)) {
        dim_type vid = paut->var_id_map.get_id(id);
        // Variable is primed: add automaton dim.
        vid += paut->dim;
        auto prae = new Rat_Affine_Expr(Var(vid));
        (yyval.rae) = prae;
      } else
        yyerror("Either variable " + id + " not defined in automaton "
                + paut->name + ", or undefined shortcut.");
      delete (yyvsp[-1].mystring);
    }
#line 3895 "parser.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1777 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (rae_map.find(id) == rae_map.end()) {
        if (paut != nullptr && paut->var_id_map.contains_name(id)) {
          dim_type vid = paut->var_id_map.get_id(id);
          auto prae = new Rat_Affine_Expr(Var(vid));
          (yyval.rae) = prae;
        } else {
          if (paut != nullptr)
            yyerror("Either variable " + id
                    + " not defined in automaton " + paut->name
                    + ", or undefined shortcut.");
          else
            yyerror("Cannot identify \"" + id +"\".");
        }
      } else {
        auto prae = new Rat_Affine_Expr(rae_map[id]);
        (yyval.rae) = prae;
      }
      delete (yyvsp[0].mystring);
    }
#line 3921 "parser.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1799 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (attempt_multiply(*((yyvsp[-2].rae)),*((yyvsp[0].rae)))) {
        (yyval.rae) = (yyvsp[-2].rae);
        delete (yyvsp[0].rae);
      } else {
        yyerror("Cannot multiply two linear expressions. ");
        cout << *((yyvsp[-2].rae)) << " and " << *((yyvsp[0].rae)) << endl;
      }
    }
#line 3935 "parser.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1809 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (attempt_division(*((yyvsp[-2].rae)),*((yyvsp[0].rae)))) {
        (yyval.rae) = (yyvsp[-2].rae);
        delete (yyvsp[0].rae);
      } else
        yyerror("Cannot divide two linear expressions.");
    }
#line 3947 "parser.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1817 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      *((yyvsp[-2].rae)) += *((yyvsp[0].rae));
      (yyval.rae) = (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3957 "parser.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1823 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      *((yyvsp[-2].rae)) -= *((yyvsp[0].rae));
      (yyval.rae) = (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3967 "parser.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1829 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      neg_assign(*(yyvsp[0].rae));
      (yyval.rae) = (yyvsp[0].rae);
    }
#line 3976 "parser.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1834 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.rae) = (yyvsp[-1].rae);
    }
#line 3984 "parser.cc" /* yacc.c:1646  */
    break;


#line 3988 "parser.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1839 "../../../phaver/src/parser.yy" /* yacc.c:1906  */

